<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 04/11/2004 *
 * ================                             Last change: 10/29/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ext-admins.php                                   *
 * -------------------------------------------------------------------- *
 * Short description : Administrator management                         *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Admin-Accountsverwaltung                         *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
}

// Version of this extension
EXT_SET_VERSION('0.7.2');

// Version history array (add more with , '0.1.0' and so on)
EXT_SET_VER_HISTORY(array('0.0', '0.1.0', '0.2.0', '0.3.0', '0.3.1', '0.4.0', '0.4.1', '0.4.2', '0.4.3', '0.4.4', '0.4.5', '0.4.6', '0.4.7', '0.4.8', '0.4.9', '0.5.0', '0.5.1', '0.5.2', '0.5.3', '0.5.4', '0.5.5', '0.5.6', '0.5.7', '0.5.8', '0.5.9', '0.6.0', '0.6.1', '0.6.2', '0.6.3', '0.6.4', '0.6.5', '0.6.6', '0.6.7', '0.6.8', '0.6.9', '0.7.0', '0.7.1', '0.7.2'));

switch ($EXT_LOAD_MODE)
{
	case 'register': // Do stuff when installation is running (modules.php?module=admin is called)
		// SQL commands to run
		ADD_EXT_SQL("INSERT INTO `{!_MYSQL_PREFIX!}_admin_menu` (`action`,`what`,`title`,`descr`,`sort`) VALUES ('admins', NULL, 'Admin-Management','Administratoren anlegen, l&ouml;schen oder Passwort/E-Mail Adresse &auml;ndern.','1')");
		ADD_EXT_SQL("INSERT INTO `{!_MYSQL_PREFIX!}_admin_menu` (`action`,`what`,`title`,`descr`,`sort`) VALUES ('admins','admins_add','Admin hinzuf&uuml;gen','Neuen Admin-Account anlegen','0')");
		ADD_EXT_SQL("INSERT INTO `{!_MYSQL_PREFIX!}_admin_menu` (`action`,`what`,`title`,`descr`,`sort`) VALUES ('admins','admins_edit','Admin-Account &auml;ndern','Bestehende Admin-Accounts bearbeiten: E-Mail-Adresse, Passwort und/oder Login-Name &auml;ndern.','1')");
		break;

	case 'remove': // Do stuff when removing extension
		// SQL commands to run
		ADD_EXT_SQL("DELETE LOW_PRIORITY FROM `{!_MYSQL_PREFIX!}_admin_menu` WHERE `action`='admins'");
		ADD_EXT_SQL("DROP TABLE IF EXISTS `{!_MYSQL_PREFIX!}_admins_acls`");
		ADD_EXT_SQL("DROP TABLE IF EXISTS `{!_MYSQL_PREFIX!}_admins_mails`");
		ADD_EXT_SQL("ALTER TABLE `{!_MYSQL_PREFIX!}_admins` DROP default_acl");

		// Remove filters
		unregisterFilter('sql_admin_extra_data', 'ADD_EXTRA_SQL_DATA', true, $dry_run);
		break;

	case 'activate': // Do stuff when admin activates this extension
		// SQL commands to run
		ADD_EXT_SQL('');
		break;

	case 'deactivate': // Do stuff when admin deactivates this extension
		// SQL commands to run
		ADD_EXT_SQL('');
		break;

	case 'update': // Update an extension
		switch ($EXT_VER)
		{
			case '0.2.0': // SQL queries for v0.2
				ADD_EXT_SQL("INSERT INTO `{!_MYSQL_PREFIX!}_admin_menu` (`action`,`what`,`title`,`descr`,`sort`) VALUES ('admins','admins_contact','Admin kontaktieren','Kontaktiert einen Admin per Mail oder Nachricht (nur wenn messaging-Erweiterung installiert ist).','2')");

				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("F&uuml;gt den Men&uuml;punkt &quot;Admin kontaktieren&quot; hinzu.");
				break;

			case '0.3.0': // SQL queries for v0.3
				// Add admin menu
				ADD_EXT_SQL("INSERT INTO `{!_MYSQL_PREFIX!}_admin_menu` (`action`,`what`,`title`,`descr`,`sort`) VALUES ('admins','config_admins','ACL einstellen','Richten Sie Zugriffskontrollzeilen f&uuml;r jeden Admin individuell ein, um ihm nur bestimmte Bereiche des Admin-Bereiches zug&auml;nglich zu machen oder zu sperren.','4')");

				// Which is the default setting when you create a new admin login?
				ADD_EXT_SQL("ALTER TABLE `{!_MYSQL_PREFIX!}_config` ADD admins_default_acl ENUM('deny','allow') NOT NULL DEFAULT 'deny'");

				// Default is deny everything
				ADD_EXT_SQL("ALTER TABLE `{!_MYSQL_PREFIX!}_admins` ADD default_acl ENUM('deny','allow') NOT NULL DEFAULT 'deny'");

				// But allow current admin everything (THIS SHALL BE YOU!)
				ADD_EXT_SQL("UPDATE `{!_MYSQL_PREFIX!}_admins` SET default_acl='allow' WHERE login='".getSession('admin_login')."' LIMIT 1");
				ADD_EXT_SQL("DROP TABLE IF EXISTS `{!_MYSQL_PREFIX!}_admins_acls`");
				ADD_EXT_SQL("CREATE TABLE `{!_MYSQL_PREFIX!}_admins_acls` (
id BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
admin_id BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
action_menu VARCHAR(255) NOT NULL DEFAULT '',
what_menu VARCHAR(255) NOT NULL DEFAULT '',
access_mode ENUM('deny','allow') NOT NULL DEFAULT 'deny',
KEY (admin_id),
PRIMARY KEY (id)
) TYPE={!_TABLE_TYPE!}");

				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("Sogn. ACLs werden hinzugef&uuml;gt: <strong>A</strong>ccess <strong>C</strong>ontrol <strong>L</strong>ines sind zu deutsch Zugriffkontrollzeilen, mit denen Sie einstellen k&ouml;nnen, was welcher Admin machen darf oder nicht.");
				break;

			case '0.3.1': // SQL queries for v0.3.1
				ADD_EXT_SQL("ALTER TABLE `{!_MYSQL_PREFIX!}_admins_acls` MODIFY id BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT");
				break;

			case '0.4.0': // SQL queries for v0.4.0
				ADD_EXT_SQL("DROP TABLE IF EXISTS `{!_MYSQL_PREFIX!}_admins_mails`");
				ADD_EXT_SQL("CREATE TABLE `{!_MYSQL_PREFIX!}_admins_mails` (
id BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
admin_id BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
mail_template VARCHAR(255) NOT NULL,
KEY (admin_id),
PRIMARY KEY (id)
) TYPE={!_TABLE_TYPE!}");
				ADD_EXT_SQL("INSERT INTO  `{!_MYSQL_PREFIX!}_admin_menu` (`action`,`what`,`title`,`descr`,`sort`) VALUES ('admins','admins_mails','Admin-Mails','Stellen Sie hier ein, welcher Admin welche Mail erhalten soll. Sie k&ouml;nnen dies (derzeit) jedoch erst, wenn einmal die Mail versendet wurde!','5')");

				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("Kontrollieren Sie, welche Mails welcher Admin oder alle (admin_id=0) bekommen soll oder im UserLog (admin_id=-1) verzeichnet werden soll. Standartm&auml;ssig wird weiter an alle versendet.");
				break;

			case '0.4.1': // SQL queries for v0.4.1
				ADD_EXT_SQL("DELETE LOW_PRIORITY FROM `{!_MYSQL_PREFIX!}_admins_mails` WHERE mail_template LIKE '% %'");

				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("Admins-Mails-Tabelle geleert.");

			case '0.4.4': // SQL queries for v0.4.4
				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("&amp;admin= in &amp;amp;admin= umgewandelt.");
				break;

			case '0.4.5': // SQL queries for v0.4.5
				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("Vorbereitet auf Cache-System");
				break;

			case '0.4.6': // SQL queries for v0.4.6
				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("Problem mit cache-Erweiterung gefixt. Der Admin-Bereich war permanent gesperrt.");
				break;

			case '0.4.7': // SQL queries for v0.4.7
				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("Es wurde die Zeitmarke der Cache-Datei admins.cache mit ber&uuml;cksichtigt.");
				break;

			case '0.4.8': // SQL queries for v0.4.8
				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("Fehler beseitigt, wenn error_reporting=E_ALL gesetzt ist.");
				break;

			case '0.4.9': // SQL queries for v0.4.9
				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("Fehler beseitigt, wenn error_reporting=E_ALL gesetzt ist.");
				break;

			case '0.5.0': // SQL queries for v0.5.0
				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("Fehler beseitigt, wenn error_reporting=E_ALL gesetzt ist.");
				break;

			case '0.5.1': // SQL queries for v0.5.1
				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("Cache wird endlich gel&oumlscht, wenn Admin entfernt wird.");
				break;

			case '0.5.2': // SQL queries for v0.5.2
				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("L&ouml;schen von Admin-Accounts repariert und HTML-Code ausgelagert in Templates.");
				break;

			case '0.5.3': // SQL queries for v0.5.3
				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("Seit <a href=\"#\">Patch 340</a> &uuml;berfl&uuml;ssige HTML-Tags entfernt.");
				break;

			case '0.5.4': // SQL queries for v0.5.4
				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("IP-Nummer und Browserbezeichnung wird in Admin-Mails eingesetzt.");
				break;

			case '0.5.5': // SQL queries for v0.5.5
				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("Men&uuml;punkt Admin-Mails korregiert: SQL-Anweisung war fehlerhaft; und HTML-Code in Templates ausgelagert.");
				break;

			case '0.5.6': // SQL queries for v0.5.6
				ADD_EXT_SQL("UPDATE `{!_MYSQL_PREFIX!}_admin_menu` SET `what`='admins_contct' WHERE `what`='admins_contact' LIMIT 1");

				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("Namenskonflikt zwischen den Erweiterungen <strong>admins</strong> und (kommender) <strong>contact</strong>.");
				break;

			case '0.5.7': // SQL queries for v0.5.7
				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("Links wegen <strong>what=admins_contct</strong> ge&auml;ndert.");
				break;

			case '0.5.8': // SQL queries for v0.5.8
				ADD_EXT_SQL("UPDATE `{!_MYSQL_PREFIX!}_admin_menu` SET `what`='admins_contct' WHERE `what`='admins_contact' LIMIT 1");

				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("Ein Punkt in der Versionsnummernliste verhinderte das 0.5.6-Update.");
				break;

			case '0.5.9': // SQL queries for v0.5.9
				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("Sicherheitsupdate: SQL-Anweisungen gesch&uuml;tzt.");
				break;

			case '0.6.0': // SQL queries for v0.6.0
				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("Link in &quot;ACL Einstellen&quot; zum Admin-Kontaktformular korregiert.");
				break;

			case '0.6.1': // SQL queries for v0.6.1
				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("Speichern von Admin-Accounts klappt wieder.");
				break;

			case '0.6.2': // SQL queries for v0.6.2
				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("Bitte verschieben Sie die admins-Templates (Ordner: {!PATH!}/templates/de/emails/) in den neuen Order admins!");
				break;

			case '0.6.3': // SQL queries for v0.6.3
				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("Abspeichern von Einstellungen repariert.");
				break;

			case '0.6.4': // SQL queries for v0.6.4
				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("Problem mit der Rechtevererbung beseitigt: Geben Sie nun ein Hauptmen&uuml; frei (Allow), dann kann der Admin auch die Untermen&uuml;s erreichen. Zudem k&ouml;nnen Sie gezielte Untermen&uuml;s im freigegeben Hauptmen&uuml; dennoch sperren.");
				break;

			case '0.6.5': // SQL queries for v0.6.5
				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("Sicherheitsupdate f&uuml;r die Include-Befehle.");
				break;

			case '0.6.6': // SQL queries for v0.5.6
				ADD_EXT_SQL("UPDATE `{!_MYSQL_PREFIX!}_admin_menu` SET `what`='admins_contct' WHERE `what`='admins_contact' LIMIT 1");

				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("Namenskonflikt zwischen den Erweiterungen <strong>admins</strong> und (kommender) <strong>contact</strong>.");
				break;

			case '0.6.7': // SQL queries for v0.6.7
				ADD_EXT_SQL("ALTER TABLE `{!_MYSQL_PREFIX!}_admins` ADD la_mode ENUM('global','OLD','NEW') NOT NULL DEFAULT 'global'");

				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("Namenskonflikt zwischen den Erweiterungen <strong>admins</strong> und (kommender) <strong>contact</strong>. Beseitigung eines Fehlers <strong>HTTP_POSR_VARS</strong> beim &Auml;ndern von Administratoren.");
				break;

			case '0.6.8': // SQL queries for v0.6.8
				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("<strong>setSession()</strong> mit @-Zeichen gegen ungewollte Ausgaben abgesichert.");
				break;

			case '0.6.9': // SQL queries for v0.6.9
				ADD_EXT_SQL("UPDATE `{!_MYSQL_PREFIX!}_admin_menu` SET title = 'Admin-Management' WHERE action = 'admins' AND (`what`='' OR `what` IS NULL) LIMIT 1");

				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("Verwaltung nach Management umbenannt.");
				break;

			case '0.7.0': // SQL queries for v0.7.0
				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("Veraltetes Update.");
				break;

			case '0.7.1': // SQL queries for v0.7.1
				// Update depends on sql_patches
				EXT_ADD_UPDATE_DEPENDS('sql_patches');

				// Add filters
				registerFilter('sql_admin_extra_data', 'ADD_EXTRA_SQL_DATA', false, true, $dry_run);

				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("Filter hinzugef&uuml;gt und ist von <strong>sql_patches</strong> abh&auml;ngig.");
				break;

			case '0.7.2': // SQL queries for v0.7.2
				ADD_EXT_SQL("ALTER TABLE `{!_MYSQL_PREFIX!}_admins` DROP login_failtures");
				ADD_EXT_SQL("ALTER TABLE `{!_MYSQL_PREFIX!}_admins` DROP last_failture");
				ADD_EXT_SQL("ALTER TABLE `{!_MYSQL_PREFIX!}_admins` ADD login_failures BIGINT(20) UNSIGNED NOT NULL DEFAULT 0");
				ADD_EXT_SQL("ALTER TABLE `{!_MYSQL_PREFIX!}_admins` ADD last_failure TIMESTAMP NOT NULL DEFAULT '0000-00-00 00:00:00'");

				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("Schreibweise korregiert.");
				break;
		}
		break;

			case 'modify': // When the extension got modified
				break;

			case 'test': // For testing purposes. For details see file inc/modules/admin/what-extensions.php, arround line 305.
				break;

			default: // Do stuff when extension is loaded
				break;
}

// Keep this extension always active!
EXT_SET_ALWAYS_ACTIVE('Y');

//
?>
