<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 10/01/2008 *
 * ================                             Last change: 10/01/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-config_removeip.php                         *
 * -------------------------------------------------------------------- *
 * Short description : Configuration for the caching system             *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Konfiguration des Caching-Systems                *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
}

// Add description as navigation point
ADD_DESCR('admin', __FILE__);

if (isFormSent()) {
	// Save configuration
	ADMIN_SAVE_SETTINGS_POST();
} else {
	// Prepare data
	switch (getConfig('removeip_anon_ip')) {
		case 'Y':
			define('__CFG_REMOVEIP_ANON_IP_Y', ' checked="checked"');
			define('__CFG_REMOVEIP_ANON_IP_N', '');
			break;

		case 'N':
			define('__CFG_REMOVEIP_ANON_IP_Y', '');
			define('__CFG_REMOVEIP_ANON_IP_N', ' checked="checked"');
			break;
	} // END - switch

	switch (getConfig('removeip_anon_host')) {
		case 'Y':
			define('__CFG_REMOVEIP_ANON_HOST_Y', ' checked="checked"');
			define('__CFG_REMOVEIP_ANON_HOST_N', '');
			break;

		case 'N':
			define('__CFG_REMOVEIP_ANON_HOST_Y', '');
			define('__CFG_REMOVEIP_ANON_HOST_N', ' checked="checked"');
			break;
	} // END - switch

	switch (getConfig('removeip_anon_ua')) {
		case 'Y':
			define('__CFG_REMOVEIP_ANON_UA_Y', ' checked="checked"');
			define('__CFG_REMOVEIP_ANON_UA_N', '');
			break;

		case 'N':
			define('__CFG_REMOVEIP_ANON_UA_Y', '');
			define('__CFG_REMOVEIP_ANON_UA_N', ' checked="checked"');
			break;
	} // END - switch

	switch (getConfig('removeip_anon_ref')) {
		case 'Y':
			define('__CFG_REMOVEIP_ANON_REF_Y', ' checked="checked"');
			define('__CFG_REMOVEIP_ANON_REF_N', '');
			break;

		case 'N':
			define('__CFG_REMOVEIP_ANON_REF_Y', '');
			define('__CFG_REMOVEIP_ANON_REF_N', ' checked="checked"');
			break;
	} // END - switch

	switch (getConfig('removeip_admin_show')) {
		case 'Y':
			define('__CFG_REMOVEIP_ADMIN_SHOW_Y', ' checked="checked"');
			define('__CFG_REMOVEIP_ADMIN_SHOW_N', '');
			break;

		case 'N':
			define('__CFG_REMOVEIP_ADMIN_SHOW_Y', '');
			define('__CFG_REMOVEIP_ADMIN_SHOW_N', ' checked="checked"');
			break;
	} // END - switch

	switch (getConfig('removeip_guest_show')) {
		case 'Y':
			define('__CFG_REMOVEIP_GUEST_SHOW_Y', ' checked="checked"');
			define('__CFG_REMOVEIP_GUEST_SHOW_N', '');
			break;

		case 'N':
			define('__CFG_REMOVEIP_GUEST_SHOW_Y', '');
			define('__CFG_REMOVEIP_GUEST_SHOW_N', ' checked="checked"');
			break;
	} // END - switch

	switch (getConfig('removeip_member_show')) {
		case 'Y':
			define('__CFG_REMOVEIP_MEMBER_SHOW_Y', ' checked="checked"');
			define('__CFG_REMOVEIP_MEMBER_SHOW_N', '');
			break;

		case 'N':
			define('__CFG_REMOVEIP_MEMBER_SHOW_Y', '');
			define('__CFG_REMOVEIP_MEMBER_SHOW_N', ' checked="checked"');
			break;
	} // END - switch

	switch (getConfig('removeip_sponsor_show')) {
		case 'Y':
			define('__CFG_REMOVEIP_SPONSOR_SHOW_Y', ' checked="checked"');
			define('__CFG_REMOVEIP_SPONSOR_SHOW_N', '');
			break;

		case 'N':
			define('__CFG_REMOVEIP_SPONSOR_SHOW_Y', '');
			define('__CFG_REMOVEIP_SPONSOR_SHOW_N', ' checked="checked"');
			break;
	} // END - switch

	switch (getConfig('anonymous_ip')) {
		case "127.0.0.1":
			define('__CFG_ANONYMOUS_IP_LOCAL' , ' selected="selected"');
			define('__CFG_ANONYMOUS_IP_ZERO'  , '');
			define('__CFG_ANONYMOUS_IP_RANDOM', '');
			break;

		case "0.0.0.0":
			define('__CFG_ANONYMOUS_IP_LOCAL' , '');
			define('__CFG_ANONYMOUS_IP_ZERO'  , ' selected="selected"');
			define('__CFG_ANONYMOUS_IP_RANDOM', '');
			break;

		case "RANDOM":
			define('__CFG_ANONYMOUS_IP_LOCAL' , '');
			define('__CFG_ANONYMOUS_IP_ZERO'  , '');
			define('__CFG_ANONYMOUS_IP_RANDOM', ' selected="selected"');
			break;
	} // END - switch

	// Load template
	LOAD_TEMPLATE("admin_config_removeip");
}
//
?>
